##############################################################################
# Copyright (c) 2008, Mooneer Salem
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the Kite Language organization nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY MOONEER SALEM ``AS IS'' AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL MOONEER SALEM BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
##############################################################################

import "__internal._regex";
import "__internal._regex_match";

/[Regular expression matching on text.]/

property internal_regex_obj;
property case_insensitive
    /[Is match case-insensitive?]/;

construct(
    regex /[Regular expression to use.]/
) /[Construct new regular expression object.]/
[
    this.internal_regex_obj = make __internal._regex(regex);
];

method match(
    str /[String to search.]/
) /[Match regular expression on text.]/
[
    this|match(str, 0);
];

method match(
    str /[String to search.]/,
    start /[Starting location to search.]/
) /[Match regular expression on text.]/
[
    this.internal_regex_obj|set_insensitive(this.case_insensitive);
    (make System.regex.match_result(this.internal_regex_obj|match(str, start)));
];

class match_result /[Regular expression result object.]/
[
    property match_begin /[Position of match.]/,
    property match_length /[Length of match.]/,
    property captures /[Captured subexpressions.]/,
    
    construct(
        arg /[internal regex match object]/) 
    /[Not directly callable.]/
    [
        property i;
        
        this.match_begin = arg|get_match_begin;
        this.match_length = arg|get_group(0)|length;
        
        i = 0;
        this.captures = [];
        while (i < arg|get_num_groups)
        [
            this.captures|append(arg|get_group(i));
            i = i + 1;
        ];
    ]
];
